Information
The topic you requested is included in another documentation set. For convenience, it's displayed below. Choose Switch to see the topic in its original location.

try-catch-finally

A common usage of catch and finally together is to obtain and use resources in a try block, deal with exceptional circumstances in a catch block, and release the resources in the finally block.

Example

// try-catch-finally
using System;
public class EHClass 
{
   public static void Main () 
   {
      try 
      {
         Console.WriteLine("Executing the try statement.");
         throw new NullReferenceException();
      }

      catch(NullReferenceException e) 
      {
         Console.WriteLine("{0} Caught exception #1.", e); 
      }

      catch 
      {
         Console.WriteLine("Caught exception #2.");
      }

      finally 
      {
         Console.WriteLine("Executing finally block.");
      }
   }
}

Output

Executing the try statement.
System.NullReferenceException: Attempted to dereference a null object reference.
   at EHClass.Main() Caught exception #1.
Executing finally block.

For more information and examples on rethrowing exceptions, see try-catch, 8.10 The try statement and Throwing Exceptions.

See Also

C# Keywords | Compare to C++ | Exception Handling Statements | throw | Throwing Exceptions | C. Grammar

Was this page helpful?
(1500 characters remaining)
Thank you for your feedback
Show:
© 2014 Microsoft